--Credit:  thrustermaster (Discord)
--Injects into nodeBeam.lua to alter wheel generation. Done here instead of wheels.lua for convenience.
local M = {}
local nodeBeam = require("common/jbeam/sections/nodeBeam")
local originalProcess = nodeBeam.process
local originalProcessNodes = processNodes
local abs = math.abs
local function simplifyWheels(vehicle)
    if vehicle["pressureWheels"] ~= nil then
    for k, v in pairs(vehicle["pressureWheels"]) do

        --EDITS

        v.hasTire = false
        --without a tire we need to do this
        v.hubRadius = v.radius

        --numray logic to keep them at same counts as simplified vehicles do
        v.numRays = math.floor(v.numRays / 1.6 + 0.5)
        if v.numRays % 2 ~= 0 then
            v.numRays = v.numRays + 1
        end

        --not sure why by cid is 0 for simplified vehicles
        v.cid = 0

        v.triangleCollision = false
        v.selfCollision = false
        v.collision = true
        v.disableHubMeshBreaking = false
        v.disableMeshBreaking = false
        v.enableBrakeThermals = false
        v.enableTireLbeams = false
        v.enableTirePeripheryReinfBeams = false
        v.enableTireReinfBeams = false
        v.enableTireSideReinfBeams = false
        v.enableTreadReinfBeams = false

        v.hubBeamDeform = v.hubBeamDeform * (75568.34375 / 19000)
        v.hubBeamStrength = v.hubBeamStrength * (85626 / 65000)

        --we set hub friction to what tire friction would be
        v.hubFrictionCoef = v.frictionCoef
        --rubber
        v.hubNodeMaterial = 4


        --scales hubPeripheryBeam values based on v.radius to not make them break stuff with bigger wheels
        local dampFactor = (150 / 6) * v.radius
        local springFactor = (301000 / 945900) * v.radius

        v.hubPeripheryBeamDamp = v.hubPeripheryBeamDamp * dampFactor
        v.hubPeripheryBeamSpring = v.hubPeripheryBeamSpring * springFactor

        --these are taken from the simplified bastion but seem to work fine for everything
        v.hubNodeWeight = v.hubNodeWeight * (0.65 / 0.45)

        v.hubRadiusSimple = 0.195
        v.hubReinfBeamDamp = 800
        v.hubReinfBeamSpring = 301000
        v.hubSideBeamDamp = 200
        v.hubSideBeamSpring = 251000
        v.hubTreadBeamDamp = 150
        v.hubTreadBeamSpring = 351000
        v.padMaterial = "sport"
        v.scaledragCoef = 2.15
        v.wheelOffset = 0
        v.treadCoef = 0.7


        --REMOVALS

        v.enableExtraHubcapBeams = nil
        v.enableHubcaps = nil
        v.disableTriangleBreaking = nil
        v.dragCoef = nil
        v.enableABS = nil
        v.frictionCoef = nil
        v.fullLoadCoef = nil
        v.hubcapAttachBeamDamp = nil
        v.hubcapAttachBeamDeform = nil
        v.hubcapAttachBeamSpring = nil
        v.hubcapAttachBeamStrength = nil
        v.hubcapBeamDamp = nil
        v.hubcapBeamDeform = nil
        v.hubcapBeamSpring = nil
        v.hubcapBeamStrength = nil
        v.hubcapCenterNodeWeight = nil
        v.hubcapCollision = nil
        v.hubcapFrictionCoef = nil
        v.hubcapNodeMaterial = nil
        v.hubcapNodeWeight = nil
        v.hubcapOffset = nil
        v.hubcapRadius = nil
        v.hubcapSelfCollision = nil
        v.hubcapSupportBeamDeform = nil
        v.hubcapSupportBeamStrength = nil
        v.hubcapWidth = nil
        v.loadSensitivitySlope = nil
        v.noLoadCoef = nil
        v.nodeMaterial = nil
        v.nodeWeight = nil
        v.padGlazingSusceptibility = nil
        v.pressurePSI = nil
        v.skinName = nil
        v.slidingFrictionCoef = nil
        v.squealCoefLowSpeed = nil
        v.squealCoefNatural = nil
        v.tireWidth = nil
        v.wheelPeripheryBeamDamp = nil
        v.wheelPeripheryBeamDampCutoffHz = nil
        v.wheelPeripheryBeamDeform = nil
        v.wheelPeripheryBeamPrecompression = nil
        v.wheelPeripheryBeamSpring = nil
        v.wheelPeripheryBeamStrength = nil
        v.wheelPeripheryReinfBeamDamp = nil
        v.wheelPeripheryReinfBeamDampCutoffHz = nil
        v.wheelPeripheryReinfBeamPrecompression = nil
        v.wheelPeripheryReinfBeamSpring = nil
        v.wheelReinfBeamDamp = nil
        v.wheelReinfBeamDampCutoffHz = nil
        v.wheelReinfBeamPrecompression = nil
        v.wheelReinfBeamSpring = nil
        v.wheelSideBeamDamp = nil
        v.wheelSideBeamDampExpansion = nil
        v.wheelSideBeamDeform = nil
        v.wheelSideBeamPrecompression = nil
        v.wheelSideBeamSpring = nil
        v.wheelSideBeamSpringExpansion = nil
        v.wheelSideBeamStrength = nil
        v.wheelSideTransitionZone = nil
        v.wheelTreadBeamDamp = nil
        v.wheelTreadBeamDampCutoffHz = nil
        v.wheelTreadBeamDeform = nil
        v.wheelTreadBeamPrecompression = nil
        v.wheelTreadBeamSpring = nil
        v.wheelTreadBeamStrength = nil
        v.wheelTreadReinfBeamDamp = nil
        v.wheelTreadReinfBeamDampCutoffHz = nil
        v.wheelTreadReinfBeamPrecompression = nil
        v.wheelTreadReinfBeamSpring = nil
    end

    else
        print("vehicle[pressureWheels] is nil")
    end
end

nodeBeam.process = function(vehicle)
    if performanceModSuper.playerSpawnProcessing or performanceModSuper.playerReloadProcessing then
        print("Skipping wheel simplifying for player vehicle")
    else
        simplifyWheels(vehicle)
        print("Applied wheel simplifying for non-player vehicle")
    end
    performanceModSuper.playerSpawnProcessing = false
   performanceModSuper.playerReloadProcessing = false

    originalProcess(vehicle)  -- Call the original process, which now includes the modified processNodes
end

M.process = nodeBeam.process

return M
